Index: pplinux/linuxnew/drivers/net/ibm_emac/ibm_ocp_enet.c
diff -u pplinux/linuxnew/drivers/net/ibm_emac/ibm_ocp_enet.c:1.1.323.1 pplinux/linuxnew/drivers/net/ibm_emac/ibm_ocp_enet.c:1.3
--- pplinux/linuxnew/drivers/net/ibm_emac/ibm_ocp_enet.c:1.1.323.1	Thu Feb  3 10:00:54 2005
+++ pplinux/linuxnew/drivers/net/ibm_emac/ibm_ocp_enet.c	Wed Apr  6 11:53:12 2005
@@ -68,6 +68,8 @@
 #include <linux/skbuff.h>
 #include <linux/crc32.h>
 
+/* to get the EMAC0_BASE for the PHYs */
+#include <platforms/ibm405ep.h>
 #include "ibm_ocp_enet.h"
 
 //#define MDIO_DEBUG(fmt) printk fmt
@@ -116,7 +118,13 @@
  * to avoid re-using the same PHY ID in cases where the arch didn't
  * setup precise emac_phy_map entries
  */
+#if 0
 static u32 busy_phy_map = 0;
+#endif
+
+int ignore_phy[2] = { 0, 0};
+
+static volatile emac_t *phy_emacp;
 
 static struct net_device_stats *
 emac_stats(struct net_device *dev)
@@ -228,19 +236,25 @@
 	register int i;
 	uint32_t stacr;
 	struct ocp_enet_private *fep = dev->priv;
+#if 0
 	volatile emac_t *emacp = fep->emacp;
+#else
+	volatile emac_t *emacp = phy_emacp;
+#endif
 
-	MDIO_DEBUG(("%s: phy_read, id: 0x%x, reg: 0x%x\n", dev->name, mii_id, reg));
+	MDIO_DEBUG(("%s: phy_read, id: 0x%x, reg: 0x%x, %p\n", dev->name, mii_id, reg, &emacp->em0stacr));
 
 	/* Enable proper ZMII port */
 	if (fep->zmii_dev)
 		emac_enable_zmii_port(fep->zmii_dev, fep->zmii_input);
+#if 0
 	/* Use the EMAC that has the MDIO port */
 	if (fep->mdio_dev) {
 		dev = fep->mdio_dev;
 		fep = dev->priv;
 	}
-	
+#endif
+
 	/* Wait for data transfer complete bit */
 	for (i = 0; i < OCP_RESET_DELAY; ++i) {
 		if (emacp->em0stacr & EMAC_STACR_OC)
@@ -287,19 +301,25 @@
 	register int i = 0;
 	uint32_t stacr;
 	struct ocp_enet_private *fep = dev->priv;
+#if 0
 	volatile emac_t *emacp = fep->emacp;
+#else
+	volatile emac_t *emacp = phy_emacp;
+#endif
 
-	MDIO_DEBUG(("%s phy_write, id: 0x%x, reg: 0x%x, data: 0x%x\n",
-            dev->name, mii_id, reg, data));
+	MDIO_DEBUG(("%s phy_write, id: 0x%x, reg: 0x%x, data: 0x%x, reg: %p\n",
+            dev->name, mii_id, reg, data, &emacp->em0stacr));
 
 	/* Enable proper ZMII port */
 	if (fep->zmii_dev)
 		emac_enable_zmii_port(fep->zmii_dev, fep->zmii_input);
+#if 0
 	/* Use the EMAC that has the MDIO port */
 	if (fep->mdio_dev) {
 		dev = fep->mdio_dev;
 		fep = dev->priv;
 	}
+#endif
 
 	/* Wait for data transfer complete bit */
 	for (i = 0; i < OCP_RESET_DELAY; ++i) {
@@ -334,6 +354,7 @@
         }
 }
 
+#if 0
 static void
 emac_wakeup_irq(int irq, void *param, struct pt_regs *regs)
 {
@@ -344,6 +365,7 @@
 	 */
 	printk(KERN_INFO "%s: WakeUp interrupt !\n", dev->name);
 }
+#endif
 
 static void
 emac_txeob_dev(void *param, u32 chanmask)
@@ -914,8 +936,7 @@
 	int forced_duplex;
 
 	/* Default advertise */
-	advertise = ADVERTISED_10baseT_Half | ADVERTISED_10baseT_Full |
-		    ADVERTISED_100baseT_Half | ADVERTISED_100baseT_Full;
+	advertise = fep->advertising;
 	autoneg = fep->want_autoneg;
 	forced_speed = fep->phy_mii.speed;
 	forced_duplex = fep->phy_mii.duplex;
@@ -924,6 +945,7 @@
 	if (ep) {
 	    if (ep->autoneg == AUTONEG_ENABLE) {
 		advertise = ep->advertising;
+		fep->advertising = advertise;
 		autoneg = 1;
 	    } else {
 		autoneg = 0;
@@ -1024,7 +1046,8 @@
         case ETHTOOL_GSET:
                 ecmd.supported = features;
                 ecmd.port = PORT_MII;
-                ecmd.transceiver = XCVR_EXTERNAL;
+		/* rwa-hack: XCVR_DUMMY1 means no PHY! */ 
+                ecmd.transceiver = ignore_phy[fep->phy_mii.mii_id] ? XCVR_DUMMY1 : XCVR_EXTERNAL;
                 ecmd.phy_address = fep->mii_phy_addr;
                 spin_lock_irq(&fep->lock);
                 ecmd.autoneg = fep->want_autoneg;
@@ -1101,7 +1124,7 @@
 emac_ioctl(struct net_device *dev, struct ifreq *rq, int cmd)
 {
 	struct ocp_enet_private *fep = dev->priv;
-	uint *data = (uint *) & rq->ifr_data;
+	ushort *data = (ushort *) & rq->ifr_data;
 
 	switch (cmd) {
         case SIOCETHTOOL:
@@ -1135,8 +1158,8 @@
 	spin_lock_irq(&fep->lock);
 
 	fep->opened = 1;
-        
-        /* Reset & configure the chip */
+ 
+	/* Reset & configure the chip */
         emac_reset_configure(fep);
 
 	spin_unlock_irq(&fep->lock);
@@ -1145,11 +1168,16 @@
 	rc = request_irq(dev->irq, emac_mac_irq, 0, "OCP EMAC MAC", dev);
 	if (rc != 0)
 		goto bail;
+	/* look into emac_wakeup_irc function for reason of commenting
+	 * this out */
+#if 0
+
 	rc = request_irq(fep->wol_irq, emac_wakeup_irq, 0, "OCP EMAC Wakeup", dev);
 	if (rc != 0) {
 		free_irq(dev->irq, dev);
 		goto bail;
 	}
+#endif
         /* Kick the chip rx & tx channels into life */ 
 	spin_lock_irq(&fep->lock);
         emac_kick(fep);
@@ -1230,7 +1258,10 @@
 	struct ocp_device *mdiodev;
 	struct net_device *mdio_ndev = NULL;
 	int commac_reg = 0;
+#if 0
 	u32 phy_map;
+#endif
+	int phy_addr;
 	
 	emacdata = (struct ocp_func_emac_data *)ocpdev->def->additions;
 	if (emacdata == NULL) {
@@ -1250,11 +1281,15 @@
 	/* If we depend on another EMAC for MDIO, wait for it to show up */
 	if (emacdata->mdio_idx >= 0 && emacdata->mdio_idx != ocpdev->def->index) {
 		mdiodev = ocp_find_device(OCP_ANY_ID, OCP_FUNC_EMAC, emacdata->mdio_idx);
-		if (mdiodev == NULL)
+		if (mdiodev == NULL) {
+			printk("didn't found other mdio if\n");
 			return -EAGAIN;
+		}
 		mdio_ndev = (struct net_device *)ocp_get_drvdata(mdiodev);
-		if (mdio_ndev == NULL)
+		if (mdio_ndev == NULL) {
+			printk("didn't found other mdio if2\n");
 			return -EAGAIN;
+		}
 	}
 
 	/* Allocate our net_device structure */
@@ -1328,6 +1363,7 @@
 	ep->phy_mii.mdio_write = emac_phy_write;
 
 	/* Find PHY */
+#if 0
 	phy_map = emac_phy_map[ocpdev->def->index] | busy_phy_map;
 	for (i = 0; i <= 0x1f; i++, phy_map >>= 1) {
 		if ((phy_map & 0x1) == 0) {
@@ -1336,14 +1372,38 @@
 			        break;
 		}
 	}
+#else
+	/* the phy address is static: emac0: 1, emac1: 0 */
+	phy_addr = ocpdev->def->index ? 0 : 1;
+	int  val = emac_phy_read(ndev, phy_addr, MII_BMCR);
+	if (ignore_phy[phy_addr]) {
+		val = 0;
+	}
+	if (val != 0xffff && val != -1) {
+		//i = ocpdev->def->index;
+		i = 0;
+	} else {
+# ifdef PP_FEAT_ETH_MAC_DIRECT_CONNECT
+		i = 0;
+		ignore_phy[phy_addr] = 1;
+# else
+		i = 0x20;
+# endif
+	}
+#endif
 	if (i == 0x20) {
 	        printk(KERN_WARNING "emac%d: Can't find PHY.\n", ocpdev->def->index);
 		rc = -ENODEV;
 		goto bail;
 	}
+#if 0
 	busy_phy_map |= 1 << i;
 	ep->mii_phy_addr = i;
 	rc = mii_phy_probe(&ep->phy_mii, i);
+#else
+	ep->mii_phy_addr = phy_addr;
+	rc = mii_phy_probe(&ep->phy_mii, phy_addr);
+#endif
 	if (rc) {
 	        printk(KERN_WARNING "emac%d: Failed to probe PHY type.\n", ocpdev->def->index);
 		rc = -ENODEV;
@@ -1354,15 +1414,25 @@
 	if (ep->phy_mii.def->ops->init)
 	        ep->phy_mii.def->ops->init(&ep->phy_mii);
 	netif_carrier_off(ndev);
-        if (ep->phy_mii.def->features & SUPPORTED_Autoneg)
+        if (ep->phy_mii.def->features & SUPPORTED_Autoneg) {
                 ep->want_autoneg = 1;
+		ep->advertising =
+			ADVERTISED_10baseT_Half | ADVERTISED_10baseT_Full |
+			ADVERTISED_100baseT_Half | ADVERTISED_100baseT_Full;
+	}
 	emac_start_link(ep, NULL);
 
 
 	/* read the MAC Address */
 	bd = (bd_t *) __res;
-	for (i = 0; i < 6; i++)
-		ndev->dev_addr[i] = bd->BD_EMAC_ADDR(ocpdev->def->index, i);	/* Marco to disques array */
+	for (i = 0; i < 6; i++) {
+#if 0
+		ndev->dev_addr[i] = bd->BD_EMAC_ADDR(ocpdev->def->index, i);
+#else
+		// use always addr 0
+		ndev->dev_addr[i] = bd->BD_EMAC_ADDR(0, i);
+#endif
+	}
 
 	/* Fill in the driver function table */
 	ndev->open = &emac_open;
@@ -1412,6 +1482,31 @@
 	.remove		= emac_remove,
 };
 
+static int __init ibm_ocp_enet_ignore_phy(char *str)
+{
+	int i;
+	
+	for (i = 0; i < 2; i++) {
+		int retval;
+		int ignore;
+
+		retval = get_option(&str, &ignore);
+
+		if (!retval)
+			break; /* no number found */
+
+		if (ignore) {
+			ignore_phy[i] = 1;
+			printk("ibm_ocp_net ignores phy on interface: %i\n", i);
+		}
+
+		if (retval != 2)
+			break; /* no next number */
+	}
+	return 1;
+}
+__setup("ibm_ocp_enet_ignore_phy=", ibm_ocp_enet_ignore_phy);
+
 static int __init
 emac_init(void)
 {
@@ -1419,11 +1514,13 @@
 	
         printk(KERN_INFO DRV_NAME ": " DRV_DESC ", version " DRV_VERSION "\n");
         printk(KERN_INFO "Maintained by " DRV_AUTHOR "\n");
-
+	printk(KERN_INFO "ignore_phy: %d, %d\n", ignore_phy[0], ignore_phy[1]);
 	if (skb_res > 2) {
 	    printk(KERN_WARNING "Invalid skb_res: %d, cropping to 2\n", skb_res);
 	    skb_res = 2;
 	}
+	phy_emacp = (volatile emac_t *)ioremap(EMAC0_BASE, sizeof (emac_t));
+
 	rc = ocp_register_driver(&emac_driver);
 	if (rc == 0) {
 		ocp_unregister_driver(&emac_driver);
@@ -1439,6 +1536,9 @@
 emac_exit(void)
 {
 	ocp_unregister_driver(&emac_driver);
+	iounmap((void*)phy_emacp);
+	/* sanity */
+	phy_emacp = NULL;
 }
 
 module_init(emac_init);
Index: pplinux/linuxnew/drivers/net/ibm_emac/ibm_ocp_enet.h
diff -u pplinux/linuxnew/drivers/net/ibm_emac/ibm_ocp_enet.h:1.1.323.1 pplinux/linuxnew/drivers/net/ibm_emac/ibm_ocp_enet.h:1.2
--- pplinux/linuxnew/drivers/net/ibm_emac/ibm_ocp_enet.h:1.1.323.1	Thu Feb  3 10:00:54 2005
+++ pplinux/linuxnew/drivers/net/ibm_emac/ibm_ocp_enet.h	Thu Feb  3 11:35:38 2005
@@ -136,6 +136,7 @@
 	struct mii_phy phy_mii;
         int mii_phy_addr;
         int want_autoneg;
+	u32 advertising;
         int timer_ticks;
 	struct timer_list link_timer;
 	struct net_device *mdio_dev;
Index: pplinux/linuxnew/drivers/net/ibm_emac/ibm_ocp_phy.c
diff -u pplinux/linuxnew/drivers/net/ibm_emac/ibm_ocp_phy.c:1.1.323.1 pplinux/linuxnew/drivers/net/ibm_emac/ibm_ocp_phy.c:1.3
--- pplinux/linuxnew/drivers/net/ibm_emac/ibm_ocp_phy.c:1.1.323.1	Thu Feb  3 10:00:54 2005
+++ pplinux/linuxnew/drivers/net/ibm_emac/ibm_ocp_phy.c	Wed Apr  6 11:53:12 2005
@@ -27,7 +27,11 @@
 
 #include "ibm_ocp_phy.h"
 
+// debug
+//#define PRINTK(fmt, args...) printk(KERN_INFO "%s: " fmt, __FUNCTION__ , ## args)
+#define PRINTK(fmt, args...)
 
+extern int ignore_phy[2];
 static inline int __phy_read(struct mii_phy* phy, int id, int reg)
 {
 	return phy->mdio_read(phy->dev, id, reg);
@@ -53,6 +57,10 @@
 	u16 val;
 	int limit = 10000;
 	
+#ifdef CONFIG_PEPPERCON
+	/* save LED configuration */
+	u16 led_cfg = __phy_read(phy, phy_id, 0x14);
+#endif
 	val = __phy_read(phy, phy_id, MII_BMCR);
 	val &= ~BMCR_ISOLATE;
 	val |= BMCR_RESET;
@@ -68,6 +76,14 @@
 	}
 	if ((val & BMCR_ISOLATE) && limit > 0)
 		__phy_write(phy, phy_id, MII_BMCR, val & ~BMCR_ISOLATE);
+#ifdef CONFIG_PEPPERCON
+	/* clear the CRS Select bit - this solves problems with 10BaseT */
+	val = __phy_read(phy, phy_id, 0x10);
+	val &= ~0x80DD; // clear CRS Select and reserved bits
+	__phy_write(phy, phy_id, 0x10, val);
+	/* restore LED configuration */
+	__phy_write(phy, phy_id, 0x14, led_cfg);
+#endif
 	
 	return (limit <= 0);
 }
@@ -75,12 +91,16 @@
 static int genmii_setup_aneg(struct mii_phy *phy, u32 advertise)
 {
 	u16 ctl, adv;
-	
 	phy->autoneg = 1;
 	phy->speed = SPEED_10;
 	phy->duplex = DUPLEX_HALF;
 	phy->pause = 0;
 	phy->advertising = advertise;
+	
+	if (phy && ignore_phy[phy->mii_id]) {
+		PRINTK("ignore phy: %d\n", phy->mii_id);
+		return 0;
+	}
 
 	/* Setup standard advertise */
 	adv = phy_read(phy, MII_ADVERTISE);
@@ -106,12 +126,16 @@
 static int genmii_setup_forced(struct mii_phy *phy, int speed, int fd)
 {
 	u16 ctl;
-	
 	phy->autoneg = 0;
 	phy->speed = speed;
 	phy->duplex = fd;
 	phy->pause = 0;
 
+	if (phy && ignore_phy[phy->mii_id]) {
+		PRINTK("ignore phy: %d\n", phy->mii_id);
+		return 0;
+	}
+
 	ctl = phy_read(phy, MII_BMCR);
 	ctl &= ~(BMCR_FULLDPLX|BMCR_SPEED100|BMCR_ANENABLE);
 
@@ -131,7 +155,11 @@
 	}
 	if (fd == DUPLEX_FULL)
 		ctl |= BMCR_FULLDPLX;
-	phy_write(phy, MII_BMCR, ctl);
+
+	/* reset recovery delay */
+	udelay(300);
+	
+	phy_write(phy, MII_BMCR, ctl); 
 
 	return 0;
 }
@@ -140,6 +168,11 @@
 {
 	u16 status;
 	
+	if ((phy && ignore_phy[phy->mii_id])) {
+		//PRINTK("not ignore phy: %d\n", phy->mii_id);
+		return 1;
+	}
+	
 	(void)phy_read(phy, MII_BMSR);
 	status = phy_read(phy, MII_BMSR);
 	if ((status & BMSR_LSTATUS) == 0)
@@ -151,16 +184,24 @@
 
 static int genmii_read_link(struct mii_phy *phy)
 {
-	u16 lpa;
+	u16 adv, lpa;
+
+	if (phy && ignore_phy[phy->mii_id]) {
+		PRINTK("ignore phy: %d\n", phy->mii_id);
+		phy->speed = SPEED_100;
+		phy->duplex = DUPLEX_FULL;
+		return 0;
+	}
 
 	if (phy->autoneg) {
+		adv = phy_read(phy, MII_ADVERTISE);
 		lpa = phy_read(phy, MII_LPA);
 
-		if (lpa & (LPA_10FULL | LPA_100FULL))
+		if ((lpa & adv) & (LPA_10FULL | LPA_100FULL))
 			phy->duplex = DUPLEX_FULL;
 		else
 			phy->duplex = DUPLEX_HALF;
-		if (lpa & (LPA_100FULL | LPA_100HALF))
+		if ((lpa & adv) & (LPA_100FULL | LPA_100HALF))
 			phy->speed = SPEED_100;
 		else
 			phy->speed = SPEED_10;
@@ -209,13 +250,21 @@
 	u32 id;
 	struct mii_phy_def* def;
 	int i;
-	
 	phy->autoneg = 0;
 	phy->advertising = 0;
 	phy->mii_id = mii_id;
 	phy->speed = 0;
 	phy->duplex = 0;
 	phy->pause = 0;
+
+	PRINTK("mii_phy_probe: %d\n", mii_id);	
+	if (ignore_phy[mii_id]) {
+		PRINTK("ignore phy: %d\n", mii_id);
+		// set some defaults, phy is not used
+		phy->def = mii_phy_table[0];
+		phy->advertising = phy->def->features;
+		return 0;
+	}
 	
 	/* Take PHY out of isloate mode and reset it. */
 	rc = reset_one_mii_phy(phy, mii_id);
Index: pplinux/linuxnew/drivers/pci/pci.c
diff -u pplinux/linuxnew/drivers/pci/pci.c:1.1.323.1 pplinux/linuxnew/drivers/pci/pci.c:1.2
--- pplinux/linuxnew/drivers/pci/pci.c:1.1.323.1	Thu Feb  3 10:00:51 2005
+++ pplinux/linuxnew/drivers/pci/pci.c	Thu Feb  3 11:35:38 2005
@@ -28,7 +28,7 @@
 #include <asm/page.h>
 #include <asm/dma.h>	/* isa_dma_bridge_buggy */
 
-#undef DEBUG
+#define DEBUG
 
 #ifdef DEBUG
 #define DBG(x...) printk(x)
Index: pplinux/linuxnew/include/asm-ppc/dma.h
diff -u pplinux/linuxnew/include/asm-ppc/dma.h:1.1.323.1 pplinux/linuxnew/include/asm-ppc/dma.h:1.2
--- pplinux/linuxnew/include/asm-ppc/dma.h:1.1.323.1	Thu Feb  3 10:00:13 2005
+++ pplinux/linuxnew/include/asm-ppc/dma.h	Thu Feb  3 11:35:38 2005
@@ -188,6 +188,8 @@
 	spin_unlock_irqrestore(&dma_spin_lock, flags);
 }
 
+#if !defined(CONFIG_PEPPERCON)
+
 /* enable/disable a specific DMA channel */
 static __inline__ void
 enable_dma(unsigned int dmanr)
@@ -370,6 +372,8 @@
 /* release it again */
 extern void free_dma(unsigned int dmanr);
 
+#endif /* !CONFIG_PEPPERCON */
+
 #ifndef MAX_DMA_CHANNELS
 #define MAX_DMA_CHANNELS	8
 #endif
Index: pplinux/linuxnew/include/asm-ppc/ibm4xx.h
diff -u pplinux/linuxnew/include/asm-ppc/ibm4xx.h:1.1.323.1 pplinux/linuxnew/include/asm-ppc/ibm4xx.h:1.2
--- pplinux/linuxnew/include/asm-ppc/ibm4xx.h:1.1.323.1	Thu Feb  3 10:00:14 2005
+++ pplinux/linuxnew/include/asm-ppc/ibm4xx.h	Thu Feb  3 11:35:38 2005
@@ -126,6 +126,10 @@
 #include <platforms/evb405ep.h>
 #endif
 
+#if defined(CONFIG_PEPPERCON)
+#include <platforms/peppercon.h>
+#endif
+
 #ifndef PPC4xx_MACHINE_NAME
 #define PPC4xx_MACHINE_NAME	"Unidentified 4xx class"
 #endif
Index: pplinux/linuxnew/include/asm-ppc/posix_types.h
diff -u pplinux/linuxnew/include/asm-ppc/posix_types.h:1.1.323.1 pplinux/linuxnew/include/asm-ppc/posix_types.h:1.2
--- pplinux/linuxnew/include/asm-ppc/posix_types.h:1.1.323.1	Thu Feb  3 10:00:13 2005
+++ pplinux/linuxnew/include/asm-ppc/posix_types.h	Thu Feb  3 11:35:38 2005
@@ -50,8 +50,7 @@
 
 #else /* __GNUC__ */
 
-#if defined(__KERNEL__) || !defined(__GLIBC__) || (__GLIBC__ < 2) \
-    || (__GLIBC__ == 2 && __GLIBC_MINOR__ == 0)
+#if defined(__KERNEL__) || !defined(__GLIBC__) || (__GLIBC__ < 2)
 /* With GNU C, use inline functions instead so args are evaluated only once: */
 
 #undef __FD_SET
Index: pplinux/linuxnew/include/asm-ppc/ppc405_pcimcs.h
diff -u /dev/null pplinux/linuxnew/include/asm-ppc/ppc405_pcimcs.h:1.1
--- /dev/null	Tue May 24 10:37:59 2005
+++ pplinux/linuxnew/include/asm-ppc/ppc405_pcimcs.h	Thu Feb  3 11:35:38 2005
@@ -0,0 +1,75 @@
+/*
+ * FILE NAME: ppc405_pcimcs.h
+ *
+ * BRIEF MODULE DESCRIPTION:
+ * machine check save pci access and configuration routines.
+ * These routines may also be used in case a certain PCI
+ * resource is physically not present. The according functions
+ * will return an error code.
+ *
+ * Author: Peppercon AG
+ *         Thomas Breitfeld <thomas@peppercon.de>
+ *
+ *  This program is free software; you can redistribute  it and/or modify it
+ *  under  the terms of  the GNU General  Public License as published by the
+ *  Free Software Foundation;  either version 2 of the  License, or (at your
+ *  option) any later version.
+ *
+ *  THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR IMPLIED
+ *  WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
+ *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
+ *  NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT, INDIRECT,
+ *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ *  NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
+ *  USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
+ *  ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
+ *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ *  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ *
+ *  You should have received a copy of the  GNU General Public License along
+ *  with this program; if not, write  to the Free Software Foundation, Inc.,
+ *  675 Mass Ave, Cambridge, MA 02139, USA.
+ */
+
+#ifdef __KERNEL__
+#ifndef __ASMPPC_405_PCIMCS_H
+#define __ASMPPC_405_PCIMCS_H
+
+#include <linux/types.h>
+#include <linux/pci.h>
+#include <asm/io.h>
+#include <asm/system.h>
+#include <asm/ibm4xx.h>
+
+/*
+ * machine check save I/O routines,
+ * an occured machine check will be signaled to the caller
+ * by setting the error flag to true
+ */
+u8 mcs_in_8(volatile u8 * addr, int * error);
+u16 mcs_in_le16(volatile u16 * addr, int * error);
+u32 mcs_in_le32(volatile u32 * addr, int * error);
+void mcs_out_8(u32 data, volatile u8 * addr, int * error);
+void mcs_out_le16(u32 data, volatile u16 * addr, int * error);
+void mcs_out_le32(u32 data, volatile u32 * addr, int * error);
+
+int mcs_pci_read_config_byte(struct pci_dev *dev, int offset, u8* value);
+int mcs_pci_read_config_word(struct pci_dev *dev, int offset, u16* value);
+int mcs_pci_read_config_dword(struct pci_dev *dev, int offset, u32* value);
+#define mcs_pci_read_config_long mcs_pci_read_config_dword
+int mcs_pci_write_config_byte(struct pci_dev *dev, int offset, u8 value);
+int mcs_pci_write_config_word(struct pci_dev *dev, int offset, u16 value);
+int mcs_pci_write_config_dword(struct pci_dev *dev, int offset, u32 value);
+#define mcs_pci_write_config_long mcs_pci_write_config_dword
+
+void fix_pci_read_config_byte(u32 cfg_addr, u32 cfg_date, int off, u8* v);
+void fix_pci_read_config_word(u32 cfg_addr, u32 cfg_date, int off, u16* v);
+void fix_pci_read_config_dword(u32 cfg_addr, u32 cfg_date, int off, u32* v);
+#define fix_pci_read_config_long fix_pci_read_config_dword
+void fix_pci_write_config_byte(u32 cfg_addr, u32 cfg_date, int off, u8 v);
+void fix_pci_write_config_word(u32 cfg_addr, u32 cfg_date, int off, u16 v);
+void fix_pci_write_config_dword(u32 cfg_addr, u32 cfg_date, int off, u32 v);
+#define fix_pci_write_config_long fix_pci_write_config_dword
+
+#endif /* __ASMPPC_405_PCIMCS_H */
+#endif /* __KERNEL__ */
Index: pplinux/linuxnew/include/asm-ppc/ppc4xx_dma.h
diff -u pplinux/linuxnew/include/asm-ppc/ppc4xx_dma.h:1.1.323.1 pplinux/linuxnew/include/asm-ppc/ppc4xx_dma.h:1.2
--- pplinux/linuxnew/include/asm-ppc/ppc4xx_dma.h:1.1.323.1	Thu Feb  3 10:00:13 2005
+++ pplinux/linuxnew/include/asm-ppc/ppc4xx_dma.h	Thu Feb  3 11:35:38 2005
@@ -583,6 +583,17 @@
 extern int ppc4xx_disable_dma_port(unsigned int dmanr, unsigned int ocp_dma,short dma_chan);
 extern int ppc4xx_set_dma_mode(unsigned int dmanr, unsigned int mode);
 
+extern void ppc4xx_set_sg_addr(int dmanr, phys_addr_t sg_addr);
+extern int  ppc4xx_add_dma_sgl(sgl_handle_t handle, phys_addr_t src_addr, phys_addr_t dst_addr,
+			       unsigned int count);
+extern void ppc4xx_enable_dma_sgl(sgl_handle_t handle);
+extern void ppc4xx_disable_dma_sgl(sgl_handle_t handle);
+extern int  ppc4xx_get_dma_sgl_residue(sgl_handle_t handle, phys_addr_t * src_addr,
+				       phys_addr_t * dst_addr);
+extern int  ppc4xx_delete_dma_sgl_element(sgl_handle_t handle, phys_addr_t * src_dma_addr,
+					  phys_addr_t * dst_dma_addr);
+extern int ppc4xx_clear_dma_sgl(sgl_handle_t handle);
+			    
 /* These are in kernel/dma.c: */
 
 /* reserve a DMA channel */
Index: pplinux/linuxnew/include/asm-ppc/ppc4xx_i2c.h
diff -u /dev/null pplinux/linuxnew/include/asm-ppc/ppc4xx_i2c.h:1.1
--- /dev/null	Tue May 24 10:37:59 2005
+++ pplinux/linuxnew/include/asm-ppc/ppc4xx_i2c.h	Thu Feb  3 11:35:38 2005
@@ -0,0 +1,123 @@
+/*
+** I2C interface
+** =============
+** (C) 2000 by Paolo Scaffardi (arsenio@tin.it)
+** AIRVENT SAM s.p.a - RIMINI(ITALY)
+**
+*/
+
+#ifndef	__PPC4XX_I2C_H__
+#define	__PPC4XX_I2C_H__
+
+#include <linux/config.h>
+
+#define CONFIG_I2C_X                    /* 16 bit access */
+#define CONFIG_RTC_X1240        1	/* we have a Xicor X1240 RTC */
+#define CFG_I2C_RTC_ADDR	0x6F    /*				  and one for RTC */
+#define CFG_I2C_EEPROM_ADDR     0x57	/* X1240 has two I2C slave addresses, one for EEPROM */
+
+#define X1240_SC			0x30
+#define X1240_MIN			0x31
+#define X1240_HR			0x32
+#define X1240_DT			0x33
+#define X1240_MO			0x34
+#define X1240_YR			0x35
+#define X1240_DW			0x36
+#define X1240_Y2K			0x37
+
+#define X1240_CONTROL			0x10
+#define X1240_STATUS			0x3F
+
+#define X1240_HR_MIL			0x80
+#define X1240_STATUS_BATTERY_FLAG  	0x20 /* not documented */
+#define X1240_STATUS_RWEL		0x04
+#define X1240_STATUS_WEL		0x02
+#define X1240_STATUS_RTCF		0x01
+
+
+#define IIC_OK		0
+#define IIC_NOK		1
+#define IIC_NOK_LA	2 /* Lost arbitration */
+#define IIC_NOK_ICT	3 /* Incomplete transfer */
+#define IIC_NOK_XFRA	4 /* Transfer aborted */
+#define IIC_NOK_DATA	5 /* No data in buffer */
+#define IIC_NOK_TOUT	6 /* Transfer timeout */
+
+#define IIC_TIMEOUT 1 /* 1 seconde */
+
+/* Registers */
+#define IICMDBUF	0x0
+#define IICSDBUF	0x2
+#define IICLMADR	0x4
+#define IICHMADR	0x5
+#define IICCNTL		0x6
+#define IICMDCNTL	0x7
+#define IICSTS		0x8
+#define IICEXTSTS	0x9
+#define IICLSADR	0xa
+#define IICHSADR	0xb
+#define IICCLKDIV	0xc
+#define IICINTRMSK	0xd
+#define IICXFRCNT	0xe
+#define IICXTCNTLSS	0xf
+#define IICDIRECTCNTL	0x10
+
+#define	   I2C_REGISTERS_BASE_ADDRESS 0xEF600500
+#define    IIC_MDBUF	((void *)(I2C_REGISTERS_BASE_ADDRESS+IICMDBUF))
+#define    IIC_SDBUF	((void *)(I2C_REGISTERS_BASE_ADDRESS+IICSDBUF))
+#define    IIC_LMADR	((void *)(I2C_REGISTERS_BASE_ADDRESS+IICLMADR))
+#define    IIC_HMADR	((void *)(I2C_REGISTERS_BASE_ADDRESS+IICHMADR))
+#define    IIC_CNTL	((void *)(I2C_REGISTERS_BASE_ADDRESS+IICCNTL))
+#define    IIC_MDCNTL	((void *)(I2C_REGISTERS_BASE_ADDRESS+IICMDCNTL))
+#define    IIC_STS	((void *)(I2C_REGISTERS_BASE_ADDRESS+IICSTS))
+#define    IIC_EXTSTS	((void *)(I2C_REGISTERS_BASE_ADDRESS+IICEXTSTS))
+#define    IIC_LSADR	((void *)(I2C_REGISTERS_BASE_ADDRESS+IICLSADR))
+#define    IIC_HSADR	((void *)(I2C_REGISTERS_BASE_ADDRESS+IICHSADR))
+#define    IIC_CLKDIV	((void *)(I2C_REGISTERS_BASE_ADDRESS+IICCLKDIV))
+#define    IIC_INTRMSK	((void *)(I2C_REGISTERS_BASE_ADDRESS+IICINTRMSK))
+#define    IIC_XFRCNT	((void *)(I2C_REGISTERS_BASE_ADDRESS+IICXFRCNT))
+#define    IIC_XTCNTLSS	((void *)(I2C_REGISTERS_BASE_ADDRESS+IICXTCNTLSS))
+#define    IIC_DIRECTCNTL ((void *)(I2C_REGISTERS_BASE_ADDRESS+IICDIRECTCNTL))
+
+/* MDCNTL Register Bit definition */
+#define    IIC_MDCNTL_HSCL 0x01
+#define    IIC_MDCNTL_EUBS 0x02
+#define    IIC_MDCNTL_FMDB 0x40
+#define    IIC_MDCNTL_FSDB 0x80
+
+/* CNTL Register Bit definition */
+#define    IIC_CNTL_PT     0x01
+#define    IIC_CNTL_READ   0x02
+#define    IIC_CNTL_CHT    0x04
+
+/* STS Register Bit definition */
+#define    IIC_STS_PT	   0x01
+#define    IIC_STS_ERR	   0x04
+#define    IIC_STS_MDBS    0x20
+
+/* EXTSTS Register Bit definition */
+#define    IIC_EXTSTS_XFRA 0x01
+#define    IIC_EXTSTS_ICT  0x02
+#define    IIC_EXTSTS_LA   0x04
+
+
+#if 0
+int  i2c_receive(unsigned char address,
+		 unsigned short size_to_expect, unsigned char datain[] );
+int  i2c_send(unsigned char address,
+		 unsigned short size_to_send, unsigned char dataout[] );
+void  i2c_read  (unsigned char *addr, int alen, unsigned char *buffer, int len);
+void  i2c_write (unsigned char *addr, int alen, unsigned char *buffer, int len);
+#endif
+void i2c_init(void);
+int rtc_read  (unsigned offset, unsigned char *buffer, unsigned cnt);
+int rtc_write (unsigned offset, unsigned char *buffer, unsigned cnt);
+
+
+#define ERROR_I2C_NONE		0
+#define ERROR_I2C_LENGTH	1
+
+#define I2C_WRITE_BIT		0x00
+#define I2C_READ_BIT		0x01
+
+#endif	/* __PPC4XX_I2C_H__ */
Index: pplinux/linuxnew/include/linux/bigphysarea.h
diff -u /dev/null pplinux/linuxnew/include/linux/bigphysarea.h:1.1
--- /dev/null	Tue May 24 10:37:59 2005
+++ pplinux/linuxnew/include/linux/bigphysarea.h	Thu Feb  3 11:35:38 2005
@@ -0,0 +1,29 @@
+/* linux/mm/bigphysarea.h, M. Welsh (mdw@cs.cornell.edu)
+ * Copyright (c) 1996 by Matt Welsh.
+ * Extended by Roger Butenuth (butenuth@uni-paderborn.de), October 1997
+ * Extended for linux-2.1.121 till 2.4.0 (June 2000)
+ *     by Pauline Middelink <middelink@polyware.nl>
+ *
+ * This is a set of routines which allow you to reserve a large (?)
+ * amount of physical memory at boot-time, which can be allocated/deallocated
+ * by drivers. This memory is intended to be used for devices such as
+ * video framegrabbers which need a lot of physical RAM (above the amount
+ * allocated by kmalloc). This is by no means efficient or recommended;
+ * to be used only in extreme circumstances.
+ *
+ */
+
+#ifndef __LINUX_BIGPHYSAREA_H
+#define __LINUX_BIGPHYSAREA_H
+
+#include <linux/types.h>
+
+/* original interface */
+extern caddr_t	bigphysarea_alloc(int size);
+extern void	bigphysarea_free(caddr_t addr, int size);
+
+/* new interface */
+extern caddr_t	bigphysarea_alloc_pages(int count, int align, int priority);
+extern void	bigphysarea_free_pages(caddr_t base);
+
+#endif // __LINUX_BIGPHYSAREA_H
Index: pplinux/linuxnew/include/linux/i2c-algo-asics.h
diff -u /dev/null pplinux/linuxnew/include/linux/i2c-algo-asics.h:1.2
--- /dev/null	Tue May 24 10:37:59 2005
+++ pplinux/linuxnew/include/linux/i2c-algo-asics.h	Mon May  9 17:11:04 2005
@@ -0,0 +1,97 @@
+/*   Copyright (C) 2004 Microtronix Datacom Ltd
+
+    This program is free software; you can redistribute it and/or modify
+    it under the terms of the GNU General Public License as published by
+    the Free Software Foundation; either version 2 of the License, or
+    (at your option) any later version.
+
+    This program is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+    GNU General Public License for more details.
+
+    You should have received a copy of the GNU General Public License
+    along with this program; if not, write to the Free Software
+    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                */
+
+#ifndef _LINUX_I2C_ALGO_ASICS_H
+#define _LINUX_I2C_ALGO_ASICS_H
+
+#include <linux/spinlock.h>
+#include <linux/i2c-slave.h>
+
+struct iic_asics_hw {
+    int base;
+    int base_offset;
+    int irq;
+    int irq_mux;        
+    /* clock and speed */
+    int clock;	/* in KHZ */
+    int scl;	/* in KHZ */
+
+    volatile u32 * asics_regs;  /* mapped ASICS registers */
+    volatile u32 * intmux_reg;	/* IRQ multiplex register */
+    wait_queue_head_t wait;
+    int pending;
+    int arbitration_lost;
+};
+
+#define SLAVE_BUF_SIZE 512
+
+typedef enum {
+	I2C_ASICS_SLAVE_OP_NONE,
+	I2C_ASICS_SLAVE_OP_READ,
+	I2C_ASICS_SLAVE_OP_WRITE
+} slave_op_t;
+
+struct i2c_algo_asics_slave_data {
+	/* slave lock object */
+	spinlock_t      slave_lock;
+	
+	/* slave write buffer */
+	unsigned char * slave_write_ptr;
+	unsigned int    slave_write_count;
+	unsigned char   slave_write_buffer[SLAVE_BUF_SIZE];
+	
+	/* slave read buffer */
+	unsigned char * slave_read_ptr;
+	unsigned int    slave_read_count;
+	unsigned char   slave_read_buffer[SLAVE_BUF_SIZE];
+	
+	/* status flags */
+	int block_next_slave_operation;
+	slave_op_t last_slave_op;
+};
+
+typedef enum {
+	I2C_ASICS_MODE_IDLE,
+	I2C_ASICS_MODE_MASTER,
+	I2C_ASICS_MODE_SLAVE
+} asics_state_t;
+
+struct i2c_algo_asics_data {
+	struct iic_asics_hw *hw;
+	struct i2c_algo_asics_slave_data *slave_data;
+	struct i2c_slave_adapter *slave_adapter;
+	
+	void (*setreg) (struct iic_asics_hw *hw, int regno, int val);
+	int  (*getreg) (struct iic_asics_hw *hw, int regno);
+	int  (*wait_for_tdone) (struct iic_asics_hw *hw);
+	
+	/* local settings */
+	int udelay;
+	int mdelay;
+	int timeout;
+	
+	asics_state_t current_state;
+};
+
+#define I2C_ASICS_ADAP_MAX	16
+
+int i2c_asics_add_bus(struct i2c_adapter *);
+int i2c_asics_del_bus(struct i2c_adapter *);
+int i2c_asics_slave_restart_xfer(struct i2c_adapter *);
+int i2c_asics_slave_set_address(struct i2c_adapter *i2c_adap, unsigned int address);
+int i2c_asics_handle_slave_request(struct i2c_adapter *);
+
+#endif /* _LINUX_I2C_ALGO_ASICS_H */
Index: pplinux/linuxnew/include/linux/i2c-id.h
diff -u pplinux/linuxnew/include/linux/i2c-id.h:1.1.323.1 pplinux/linuxnew/include/linux/i2c-id.h:1.2
--- pplinux/linuxnew/include/linux/i2c-id.h:1.1.323.1	Thu Feb  3 10:00:16 2005
+++ pplinux/linuxnew/include/linux/i2c-id.h	Wed Feb 23 18:03:37 2005
@@ -157,6 +157,8 @@
 #define I2C_ALGO_SGI	0x130000	/* SGI algorithm		*/
 #define I2C_ALGO_OCP    0x140000        /* IBM or otherwise On-chip I2C algorithm */
 
+/* Opencores was here */
+#define I2C_ALGO_ASICS  0x160000
 #define I2C_ALGO_EXP	0x800000	/* experimental			*/
 
 #define I2C_ALGO_MASK	0xff0000	/* Mask for algorithms		*/
@@ -192,6 +194,12 @@
 #define I2C_HW_P_ISA	0x01	/* generic ISA Bus inteface card	*/
 #define I2C_HW_P_ELEK	0x02	/* Elektor ISA Bus inteface card	*/
 
+/* --- Opencores I2C based adaptors */
+#define I2C_HW_OC_UKIT 0x00     /* what is on Microtronix uKit */
+
+/* --- Asics I2C Master/Slave based adaptors */
+#define I2C_HW_ASICS_UKIT 0x00   /* what is on Microtronix uKit */
+
 /* --- ACPI Embedded controller algorithms                              */
 #define I2C_HW_ACPI_EC          0x00
 
